<?xml version="1.0"?>

<ruleset name="Custom ruleset" xmlns="http://pmd.sourceforge.net/ruleset/2.0.0"
         xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
         xsi:schemaLocation="http://pmd.sourceforge.net/ruleset/2.0.0 http://pmd.sourceforge.net/ruleset_2_0_0.xsd">

  <description>
    Custom NDD rules.
    See ndd-maven-quality for a baseline.
    See https://github.com/pmd/pmd/issues/3503 for a solution.
  </description>

  <rule ref="pmd/pmd-base-main.xml">
  </rule>

  <rule ref="category/java/codestyle.xml/ClassNamingConventions">
    <properties>
      <property name="utilityClassPattern" value="[A-Z][a-zA-Z0-9]+(Utils?|Helper|Constants|Checkers|Utilities)" />
    </properties>
  </rule>
  <rule ref="category/java/codestyle.xml/LinguisticNaming">
    <properties>
      <property name="violationSuppressRegex"
                value=".*The method 'is.+' indicates linguistically it returns a boolean, but it returns '(C|.+Checker)'" />
    </properties>
  </rule>

  <rule ref="category/java/design.xml/CyclomaticComplexity">
    <properties>
      <property name="violationSuppressXPath"
                value="//ClassOrInterfaceDeclaration[@SimpleName='ConciseCheckers']" />
    </properties>
  </rule>
  <rule ref="category/java/design.xml/ExcessiveClassLength">
    <properties>
      <property name="violationSuppressXPath"
                value="//ClassOrInterfaceDeclaration[@SimpleName='ConciseCheckers']" />
    </properties>
  </rule>
  <rule ref="category/java/design.xml/ExcessivePublicCount">
    <properties>
      <property name="violationSuppressXPath"
                value="//ClassOrInterfaceDeclaration[@SimpleName='ConciseCheckers']" />
    </properties>
  </rule>
  <rule ref="category/java/design.xml/TooManyMethods">
    <properties>
      <property name="violationSuppressXPath"
                value="//ClassOrInterfaceDeclaration[@SimpleName='ConciseCheckers']" />
    </properties>
  </rule>

</ruleset>
